import { LRParser } from '@lezer/lr';
import { LRLanguage, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';
import { completeFromList } from '@codemirror/autocomplete';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 13,
  states: "!jOVQPOOO_QPO'#C^OOQO'#C^'#C^QOQPOOOmQPO,58{OxQPO'#ChO!QQPO1G.gOVQPO'#CbO!VQPO,59SOOQO7+$R7+$ROOQO,58|,58|OOQO-E6`-E6`",
  stateData: "!_~OXOS~ORQOSPO~OZSOVQXYQX]QX~ORQOSPOY[P~O]VOY[X~OYXO~O]VOY[a~O",
  goto: "u]PP^PPglPPPPPrQROQTSRYVVQOSVQWTRZWRUS",
  nodeNames: "⚠ Program Expr String Identifier Application",
  maxTerm: 13,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "#u~R^XY}YZ}]^}pq}rs!`xy!}yz#S|}#X}!O#^!O!P#^!Q![#^!c!}#^#R#S#^#T#o#^~!SSX~XY}YZ}]^}pq}~!cTOr!`rs!rs#O!`#O#P!w#P~!`~!wOR~~!zPO~!`~#SOZ~~#XOY~~#^O]~~#cUS~}!O#^!O!P#^!Q![#^!c!}#^#R#S#^#T#o#^",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const BSLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            styleTags({
                Identifier: tags.variableName,
                String: tags.string,
                "( )": tags.paren
            })
        ]
    }),
    languageData: {
        closeBrackets: { brackets: ['('] }
    }
});
const bslangCompletion = (sources) => {
    return BSLanguage.data.of({
        autocomplete: completeFromList([
            { label: "avg", type: "function" },
            { label: "sum", type: "function" },
            { label: "zSpread", type: "function" },
        ].concat(sources))
    });
};
function BSLANG(autocompletionSources = []) {
    return new LanguageSupport(BSLanguage, [bslangCompletion(autocompletionSources)]);
}

function makeASTNode(name) {
    return {
        name,
        children: []
    };
}
function parseSyntaxTree(tree, state) {
    let head = tree.topNode;
    let root = makeASTNode(head.name);
    function helper(parent, node) {
        if (!(node === null || node === void 0 ? void 0 : node.name)) {
            return;
        }
        let newNode = makeASTNode(node.name);
        if (node.name === 'Identifier') {
            newNode.content = state.sliceDoc(node.from, node.to);
        }
        parent.children.push(newNode);
        helper(newNode, node.firstChild);
        helper(parent, node.nextSibling);
    }
    helper(root, head.firstChild);
    return root;
}

export { BSLANG, BSLanguage, bslangCompletion, parseSyntaxTree };
